diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.1.pl /home/packages/code/qi/SOURCES/wordpress-3.5/wp-content/plugins/akismet/akismet.php /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-content/plugins/akismet/akismet.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5/wp-content/plugins/akismet/akismet.php	2012-12-17 16:18:44.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-content/plugins/akismet/akismet.php	2012-12-13 15:08:41.000000000 -0600
***************
*** 5,12 ****
  /*
  Plugin Name: Akismet
  Plugin URI: http://akismet.com/?return=true
! Description: Used by millions, Akismet is quite possibly the best way in the world to <strong>protect your blog from comment and trackback spam</strong>. It keeps your site protected from spam even while you sleep. To get started: 1) Click the "Activate" link to the left of this description, 2) <a href="http://akismet.com/get/?return=true">Sign up for an Akismet API key</a>, and 3) Go to your <a href="admin.php?page=akismet-key-config">Akismet configuration</a> page, and save your API key.
! Version: 2.5.6
  Author: Automattic
  Author URI: http://automattic.com/wordpress-plugins/
  License: GPLv2 or later
--- 5,12 ----
  /*
  Plugin Name: Akismet
  Plugin URI: http://akismet.com/?return=true
! Description: Used by millions, Akismet is quite possibly the best way in the world to <strong>protect your blog from comment and trackback spam</strong>. It keeps your site protected from spam even while you sleep. To get started: 1) Click the "Activate" link to the left of this description, 2) <a href="http://akismet.com/get/?return=true">Sign up for an Akismet API key</a>, and 3) Go to your Akismet configuration page, and save your API key.
! Version: 2.5.7
  Author: Automattic
  Author URI: http://automattic.com/wordpress-plugins/
  License: GPLv2 or later
***************
*** 28,34 ****
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
  */
  
! define('AKISMET_VERSION', '2.5.6');
  define('AKISMET_PLUGIN_URL', plugin_dir_url( __FILE__ ));
  
  /** If you hardcode a WP.com API key here, all key config screens will be hidden */
--- 28,40 ----
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
  */
  
! // Make sure we don't expose any info if called directly
! if ( !function_exists( 'add_action' ) ) {
! 	echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
! 	exit;
! }
! 
! define('AKISMET_VERSION', '2.5.7');
  define('AKISMET_PLUGIN_URL', plugin_dir_url( __FILE__ ));
  
  /** If you hardcode a WP.com API key here, all key config screens will be hidden */
***************
*** 37,48 ****
  else
  	$wpcom_api_key = '';
  
- // Make sure we don't expose any info if called directly
- if ( !function_exists( 'add_action' ) ) {
- 	echo "Hi there!  I'm just a plugin, not much I can do when called directly.";
- 	exit;
- }
- 
  if ( isset($wp_db_version) && $wp_db_version <= 9872 )
  	include_once dirname( __FILE__ ) . '/legacy.php';
  
--- 43,48 ----
***************
*** 110,116 ****
  }
  
  // return a comma-separated list of role names for the given user
! function akismet_get_user_roles($user_id ) {
  	$roles = false;
  	
  	if ( !class_exists('WP_User') )
--- 110,116 ----
  }
  
  // return a comma-separated list of role names for the given user
! function akismet_get_user_roles( $user_id ) {
  	$roles = false;
  	
  	if ( !class_exists('WP_User') )
***************
*** 277,286 ****
  	if ( !function_exists('add_comment_meta') )
  		return false;
  
  	// wp_insert_comment() might be called in other contexts, so make sure this is the same comment
  	// as was checked by akismet_auto_check_comment
  	if ( is_object($comment) && !empty($akismet_last_comment) && is_array($akismet_last_comment) ) {
! 		if ( intval($akismet_last_comment['comment_post_ID']) == intval($comment->comment_post_ID)
  			&& $akismet_last_comment['comment_author'] == $comment->comment_author
  			&& $akismet_last_comment['comment_author_email'] == $comment->comment_author_email ) {
  				// normal result: true or false
--- 277,289 ----
  	if ( !function_exists('add_comment_meta') )
  		return false;
  
+ 	if ( !isset( $akismet_last_comment['comment_author_email'] ) )
+ 		$akismet_last_comment['comment_author_email'] = '';
+ 
  	// wp_insert_comment() might be called in other contexts, so make sure this is the same comment
  	// as was checked by akismet_auto_check_comment
  	if ( is_object($comment) && !empty($akismet_last_comment) && is_array($akismet_last_comment) ) {
! 		if ( isset($akismet_last_comment['comment_post_ID']) && intval($akismet_last_comment['comment_post_ID']) == intval($comment->comment_post_ID)
  			&& $akismet_last_comment['comment_author'] == $comment->comment_author
  			&& $akismet_last_comment['comment_author_email'] == $comment->comment_author_email ) {
  				// normal result: true or false
***************
*** 319,333 ****
  
  	$comment = $commentdata;
  	$comment['user_ip']    = $_SERVER['REMOTE_ADDR'];
! 	$comment['user_agent'] = $_SERVER['HTTP_USER_AGENT'];
! 	$comment['referrer']   = $_SERVER['HTTP_REFERER'];
  	$comment['blog']       = get_option('home');
  	$comment['blog_lang']  = get_locale();
  	$comment['blog_charset'] = get_option('blog_charset');
  	$comment['permalink']  = get_permalink($comment['comment_post_ID']);
  	
  	if ( !empty( $comment['user_ID'] ) ) {
! 		$comment['user_role'] = akismet_get_user_roles($comment['user_ID']);
  	}
  
  	$akismet_nonce_option = apply_filters( 'akismet_comment_nonce', get_option( 'akismet_comment_nonce' ) );
--- 322,336 ----
  
  	$comment = $commentdata;
  	$comment['user_ip']    = $_SERVER['REMOTE_ADDR'];
! 	$comment['user_agent'] = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : null; 
! 	$comment['referrer']   = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : null;
  	$comment['blog']       = get_option('home');
  	$comment['blog_lang']  = get_locale();
  	$comment['blog_charset'] = get_option('blog_charset');
  	$comment['permalink']  = get_permalink($comment['comment_post_ID']);
  	
  	if ( !empty( $comment['user_ID'] ) ) {
! 		$comment['user_role'] = akismet_get_user_roles( $comment['user_ID'] );
  	}
  
  	$akismet_nonce_option = apply_filters( 'akismet_comment_nonce', get_option( 'akismet_comment_nonce' ) );
***************
*** 370,375 ****
--- 373,379 ----
  	$commentdata['comment_as_submitted'] = $comment;
  
  	$response = akismet_http_post($query_string, $akismet_api_host, '/1.1/comment-check', $akismet_api_port);
+ 	do_action( 'akismet_comment_check_response', $response );
  	akismet_update_alert( $response );
  	$commentdata['akismet_result'] = $response[1];
  	if ( 'true' == $response[1] ) {
***************
*** 386,392 ****
  			// akismet_result_spam() won't be called so bump the counter here
  			if ( $incr = apply_filters('akismet_spam_count_incr', 1) )
  				update_option( 'akismet_spam_count', get_option('akismet_spam_count') + $incr );
! 			wp_safe_redirect( $_SERVER['HTTP_REFERER'] );
  			die();
  		}
  	}
--- 390,397 ----
  			// akismet_result_spam() won't be called so bump the counter here
  			if ( $incr = apply_filters('akismet_spam_count_incr', 1) )
  				update_option( 'akismet_spam_count', get_option('akismet_spam_count') + $incr );
! 			$redirect_to = isset( $_SERVER['HTTP_REFERER'] ) ? $_SERVER['HTTP_REFERER'] : get_permalink( $post );
! 			wp_safe_redirect( $redirect_to );
  			die();
  		}
  	}
***************
*** 498,504 ****
      $query_string .= $key . '=' . urlencode( stripslashes($data) ) . '&';
  
      $response = akismet_http_post($query_string, $akismet_api_host, '/1.1/comment-check', $akismet_api_port);
!     return $response[1];
  }
  
  function akismet_cron_recheck() {
--- 503,509 ----
      $query_string .= $key . '=' . urlencode( stripslashes($data) ) . '&';
  
      $response = akismet_http_post($query_string, $akismet_api_host, '/1.1/comment-check', $akismet_api_port);
!     return ( is_array( $response ) && isset( $response[1] ) ) ? $response[1] : false;
  }
  
  function akismet_cron_recheck() {
***************
*** 565,571 ****
  		delete_comment_meta( $comment_id, 'akismet_rechecking' );
  	}
  	
! 	$remaining = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(*) FROM $wpdb->commentmeta WHERE meta_key = 'akismet_error'" ) );
  	if ( $remaining && !wp_next_scheduled('akismet_schedule_cron_recheck') ) {
  		wp_schedule_single_event( time() + 1200, 'akismet_schedule_cron_recheck' );
  	}
--- 570,576 ----
  		delete_comment_meta( $comment_id, 'akismet_rechecking' );
  	}
  	
! 	$remaining = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->commentmeta WHERE meta_key = 'akismet_error'" );
  	if ( $remaining && !wp_next_scheduled('akismet_schedule_cron_recheck') ) {
  		wp_schedule_single_event( time() + 1200, 'akismet_schedule_cron_recheck' );
  	}
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.1.pl /home/packages/code/qi/SOURCES/wordpress-3.5/wp-content/plugins/akismet/.htaccess /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-content/plugins/akismet/.htaccess
*** /home/packages/code/qi/SOURCES/wordpress-3.5/wp-content/plugins/akismet/.htaccess	1969-12-31 17:00:00.000000000 -0700
--- /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-content/plugins/akismet/.htaccess	2012-12-12 23:48:36.000000000 -0600
***************
*** 0 ****
--- 1,6 ----
+ Order Deny,Allow
+ Deny from all
+ 
+ <FilesMatch "^akismet\.(css|js)$">
+ 	Allow from all
+ </FilesMatch>
\ No newline at end of file
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.1.pl /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-http.php /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/class-http.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-http.php	2012-12-17 16:18:40.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/class-http.php	2013-01-03 00:24:01.000000000 -0600
***************
*** 141,147 ****
  		// Force some settings if we are streaming to a file and check for existence and perms of destination directory
  		if ( $r['stream'] ) {
  			$r['blocking'] = true;
! 			if ( ! is_writable( dirname( $r['filename'] ) ) )
  				return new WP_Error( 'http_request_failed', __( 'Destination directory for file streaming does not exist or is not writable.' ) );
  		}
  
--- 141,147 ----
  		// Force some settings if we are streaming to a file and check for existence and perms of destination directory
  		if ( $r['stream'] ) {
  			$r['blocking'] = true;
! 			if ( ! call_user_func( 'WIN' === strtoupper( substr( PHP_OS, 0, 3 ) ) ? 'win_is_writable' : 'is_writable', dirname( $r['filename'] ) ) )
  				return new WP_Error( 'http_request_failed', __( 'Destination directory for file streaming does not exist or is not writable.' ) );
  		}
  
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.1.pl /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-embed.php /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/class-wp-embed.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-embed.php	2012-12-17 16:18:39.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/class-wp-embed.php	2013-01-22 10:38:32.000000000 -0600
***************
*** 270,276 ****
  	 * @return string Linked URL or the original URL.
  	 */
  	function maybe_make_link( $url ) {
! 		$output = ( $this->linkifunknown ) ? '<a href="' . esc_attr($url) . '">' . esc_html($url) . '</a>' : $url;
  		return apply_filters( 'embed_maybe_make_link', $output, $url );
  	}
  }
--- 270,276 ----
  	 * @return string Linked URL or the original URL.
  	 */
  	function maybe_make_link( $url ) {
! 		$output = ( $this->linkifunknown ) ? '<a href="' . esc_url($url) . '">' . esc_html($url) . '</a>' : $url;
  		return apply_filters( 'embed_maybe_make_link', $output, $url );
  	}
  }
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.1.pl /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp.php /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/class-wp.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp.php	2012-12-17 16:18:40.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/class-wp.php	2013-01-04 16:52:10.000000000 -0600
***************
*** 378,389 ****
  
  		if ( ! empty( $status ) )
  			status_header( $status );
  		foreach( (array) $headers as $name => $field_value )
  			@header("{$name}: {$field_value}");
  
- 		if ( isset( $headers['Last-Modified'] ) && empty( $headers['Last-Modified'] ) && function_exists( 'header_remove' ) )
- 			@header_remove( 'Last-Modified' );
- 
  		if ( $exit_required )
  			exit();
  
--- 378,406 ----
  
  		if ( ! empty( $status ) )
  			status_header( $status );
+ 
+ 		// If Last-Modified is set to false, it should not be sent (no-cache situation).
+ 		if ( isset( $headers['Last-Modified'] ) && false === $headers['Last-Modified'] ) {
+ 			unset( $headers['Last-Modified'] );
+ 
+ 			// In PHP 5.3+, make sure we are not sending a Last-Modified header.
+ 			if ( function_exists( 'header_remove' ) ) {
+ 				@header_remove( 'Last-Modified' );
+ 			} else {
+ 				// In PHP 5.2, send an empty Last-Modified header, but only as a
+ 				// last resort to override a header already sent. #WP23021
+ 				foreach ( headers_list() as $header ) {
+ 					if ( 0 === stripos( $header, 'Last-Modified' ) ) {
+ 						$headers['Last-Modified'] = '';
+ 						break;
+ 					}
+ 				}
+ 			}
+ 		}
+ 
  		foreach( (array) $headers as $name => $field_value )
  			@header("{$name}: {$field_value}");
  
  		if ( $exit_required )
  			exit();
  
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.1.pl /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-xmlrpc-server.php /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/class-wp-xmlrpc-server.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-xmlrpc-server.php	2012-12-17 16:18:41.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/class-wp-xmlrpc-server.php	2013-01-22 16:32:06.000000000 -0600
***************
*** 5309,5318 ****
  		$pagelinkedto = str_replace('&amp;', '&', $pagelinkedto);
  		$pagelinkedto = str_replace('&', '&amp;', $pagelinkedto);
  
  		// Check if the page linked to is in our site
  		$pos1 = strpos($pagelinkedto, str_replace(array('http://www.','http://','https://www.','https://'), '', get_option('home')));
  		if ( !$pos1 )
! 			return new IXR_Error(0, __('Is there no link to us?'));
  
  		// let's find which post is linked to
  		// FIXME: does url_to_postid() cover all these cases already?
--- 5309,5322 ----
  		$pagelinkedto = str_replace('&amp;', '&', $pagelinkedto);
  		$pagelinkedto = str_replace('&', '&amp;', $pagelinkedto);
  
+ 		$pagelinkedfrom = apply_filters( 'pingback_ping_source_uri', $pagelinkedfrom, $pagelinkedto );
+ 		if ( ! $pagelinkedfrom )
+ 			return $this->pingback_error( 0, __( 'A valid URL was not provided.' ) );
+ 
  		// Check if the page linked to is in our site
  		$pos1 = strpos($pagelinkedto, str_replace(array('http://www.','http://','https://www.','https://'), '', get_option('home')));
  		if ( !$pos1 )
! 			return $this->pingback_error( 0, __( 'Is there no link to us?' ) );
  
  		// let's find which post is linked to
  		// FIXME: does url_to_postid() cover all these cases already?
***************
*** 5346,5384 ****
  				$sql = $wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE post_title RLIKE %s", like_escape( $title ) );
  				if (! ($post_ID = $wpdb->get_var($sql)) ) {
  					// returning unknown error '0' is better than die()ing
! 			  		return new IXR_Error(0, '');
  				}
  				$way = 'from the fragment (title)';
  			}
  		} else {
  			// TODO: Attempt to extract a post ID from the given URL
! 	  		return new IXR_Error(33, __('The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.'));
  		}
  		$post_ID = (int) $post_ID;
  
  		$post = get_post($post_ID);
  
  		if ( !$post ) // Post_ID not found
! 	  		return new IXR_Error(33, __('The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.'));
  
  		if ( $post_ID == url_to_postid($pagelinkedfrom) )
! 			return new IXR_Error(0, __('The source URL and the target URL cannot both point to the same resource.'));
  
  		// Check if pings are on
  		if ( !pings_open($post) )
! 	  		return new IXR_Error(33, __('The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.'));
  
  		// Let's check that the remote site didn't already pingback this entry
  		if ( $wpdb->get_results( $wpdb->prepare("SELECT * FROM $wpdb->comments WHERE comment_post_ID = %d AND comment_author_url = %s", $post_ID, $pagelinkedfrom) ) )
! 			return new IXR_Error( 48, __( 'The pingback has already been registered.' ) );
  
  		// very stupid, but gives time to the 'from' server to publish !
  		sleep(1);
  
  		// Let's check the remote site
! 		$linea = wp_remote_fopen( $pagelinkedfrom );
  		if ( !$linea )
! 	  		return new IXR_Error(16, __('The source URL does not exist.'));
  
  		$linea = apply_filters('pre_remote_source', $linea, $pagelinkedto);
  
--- 5350,5388 ----
  				$sql = $wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE post_title RLIKE %s", like_escape( $title ) );
  				if (! ($post_ID = $wpdb->get_var($sql)) ) {
  					// returning unknown error '0' is better than die()ing
! 			  		return $this->pingback_error( 0, '' );
  				}
  				$way = 'from the fragment (title)';
  			}
  		} else {
  			// TODO: Attempt to extract a post ID from the given URL
! 	  		return $this->pingback_error( 33, __('The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.' ) );
  		}
  		$post_ID = (int) $post_ID;
  
  		$post = get_post($post_ID);
  
  		if ( !$post ) // Post_ID not found
! 	  		return $this->pingback_error( 33, __( 'The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.' ) );
  
  		if ( $post_ID == url_to_postid($pagelinkedfrom) )
! 			return $this->pingback_error( 0, __( 'The source URL and the target URL cannot both point to the same resource.' ) );
  
  		// Check if pings are on
  		if ( !pings_open($post) )
! 	  		return $this->pingback_error( 33, __( 'The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.' ) );
  
  		// Let's check that the remote site didn't already pingback this entry
  		if ( $wpdb->get_results( $wpdb->prepare("SELECT * FROM $wpdb->comments WHERE comment_post_ID = %d AND comment_author_url = %s", $post_ID, $pagelinkedfrom) ) )
! 			return $this->pingback_error( 48, __( 'The pingback has already been registered.' ) );
  
  		// very stupid, but gives time to the 'from' server to publish !
  		sleep(1);
  
  		// Let's check the remote site
! 		$linea = wp_remote_retrieve_body( wp_remote_get( $pagelinkedfrom, array( 'timeout' => 10, 'redirection' => 0 ) ) );
  		if ( !$linea )
! 	  		return $this->pingback_error( 16, __( 'The source URL does not exist.' ) );
  
  		$linea = apply_filters('pre_remote_source', $linea, $pagelinkedto);
  
***************
*** 5390,5396 ****
  		preg_match('|<title>([^<]*?)</title>|is', $linea, $matchtitle);
  		$title = $matchtitle[1];
  		if ( empty( $title ) )
! 			return new IXR_Error(32, __('We cannot find a title on that page.'));
  
  		$linea = strip_tags( $linea, '<a>' ); // just keep the tag we need
  
--- 5394,5400 ----
  		preg_match('|<title>([^<]*?)</title>|is', $linea, $matchtitle);
  		$title = $matchtitle[1];
  		if ( empty( $title ) )
! 			return $this->pingback_error( 32, __('We cannot find a title on that page.' ) );
  
  		$linea = strip_tags( $linea, '<a>' ); // just keep the tag we need
  
***************
*** 5426,5432 ****
  		}
  
  		if ( empty($context) ) // Link to target not found
! 			return new IXR_Error(17, __('The source URL does not contain a link to the target URL, and so cannot be used as a source.'));
  
  		$pagelinkedfrom = str_replace('&', '&amp;', $pagelinkedfrom);
  
--- 5430,5436 ----
  		}
  
  		if ( empty($context) ) // Link to target not found
! 			return $this->pingback_error( 17, __( 'The source URL does not contain a link to the target URL, and so cannot be used as a source.' ) );
  
  		$pagelinkedfrom = str_replace('&', '&amp;', $pagelinkedfrom);
  
***************
*** 5473,5486 ****
  		$post_ID = url_to_postid($url);
  		if ( !$post_ID ) {
  			// We aren't sure that the resource is available and/or pingback enabled
! 	  		return new IXR_Error(33, __('The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.'));
  		}
  
  		$actual_post = get_post($post_ID, ARRAY_A);
  
  		if ( !$actual_post ) {
  			// No such post = resource not found
! 	  		return new IXR_Error(32, __('The specified target URL does not exist.'));
  		}
  
  		$comments = $wpdb->get_results( $wpdb->prepare("SELECT comment_author_url, comment_content, comment_author_IP, comment_type FROM $wpdb->comments WHERE comment_post_ID = %d", $post_ID) );
--- 5477,5490 ----
  		$post_ID = url_to_postid($url);
  		if ( !$post_ID ) {
  			// We aren't sure that the resource is available and/or pingback enabled
! 	  		return $this->pingback_error( 33, __( 'The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.' ) );
  		}
  
  		$actual_post = get_post($post_ID, ARRAY_A);
  
  		if ( !$actual_post ) {
  			// No such post = resource not found
! 	  		return $this->pingback_error( 32, __('The specified target URL does not exist.' ) );
  		}
  
  		$comments = $wpdb->get_results( $wpdb->prepare("SELECT comment_author_url, comment_content, comment_author_IP, comment_type FROM $wpdb->comments WHERE comment_post_ID = %d", $post_ID) );
***************
*** 5496,5499 ****
--- 5500,5507 ----
  
  		return $pingbacks;
  	}
+ 
+ 	protected function pingback_error( $code, $message ) {
+ 		return apply_filters( 'xmlrpc_pingback_error', new IXR_Error( $code, $message ) );
+ 	}
  }
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.1.pl /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/comment.php /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/comment.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/comment.php	2012-12-17 16:18:40.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/comment.php	2013-01-22 16:38:46.000000000 -0600
***************
*** 290,302 ****
  				'user_id',
  			);
  			if ( ! empty( $this->query_vars['meta_key'] ) ) {
! 				$allowed_keys[] = $q['meta_key'];
  				$allowed_keys[] = 'meta_value';
  				$allowed_keys[] = 'meta_value_num';
  			}
  			$ordersby = array_intersect( $ordersby, $allowed_keys );
  			foreach ( $ordersby as $key => $value ) {
! 				if ( $value == $q['meta_key'] || $value == 'meta_value' ) {
  					$ordersby[ $key ] = "$wpdb->commentmeta.meta_value";
  				} elseif ( $value == 'meta_value_num' ) {
  					$ordersby[ $key ] = "$wpdb->commentmeta.meta_value+0";
--- 290,302 ----
  				'user_id',
  			);
  			if ( ! empty( $this->query_vars['meta_key'] ) ) {
! 				$allowed_keys[] = $this->query_vars['meta_key'];
  				$allowed_keys[] = 'meta_value';
  				$allowed_keys[] = 'meta_value_num';
  			}
  			$ordersby = array_intersect( $ordersby, $allowed_keys );
  			foreach ( $ordersby as $key => $value ) {
! 				if ( $value == $this->query_vars['meta_key'] || $value == 'meta_value' ) {
  					$ordersby[ $key ] = "$wpdb->commentmeta.meta_value";
  				} elseif ( $value == 'meta_value_num' ) {
  					$ordersby[ $key ] = "$wpdb->commentmeta.meta_value+0";
***************
*** 1951,1956 ****
--- 1951,2036 ----
  		$client->query('weblogUpdates.ping', get_option('blogname'), $home);
  }
  
+ /**
+  * Default filter attached to pingback_ping_source_uri to validate the pingback's Source URI
+  *
+  * @since 3.5.1
+  *
+  * @param string $source_uri
+  * @return string
+  */
+ function pingback_ping_source_uri( $source_uri ) {
+ 	$uri = esc_url_raw( $source_uri, array( 'http', 'https' ) );
+ 	if ( ! $uri )
+ 		return '';
+ 
+ 	$parsed_url = @parse_url( $uri );
+ 	if ( ! $parsed_url )
+ 		return '';
+ 
+ 	if ( isset( $parsed_url['user'] ) || isset( $parsed_url['pass'] ) )
+ 		return '';
+ 
+ 	if ( false !== strpos( $parsed_url['host'], ':' ) )
+ 		return '';
+ 
+ 	$parsed_home = @parse_url( get_option( 'home' ) );
+ 
+ 	$same_host = strtolower( $parsed_home['host'] ) === strtolower( $parsed_url['host'] );
+ 
+ 	if ( ! $same_host ) {
+ 		$host = trim( $parsed_url['host'], '.' );
+ 		if ( preg_match( '#^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$#', $host ) ) {
+ 			$ip = $host;
+ 		} else {
+ 			$ip = gethostbyname( $host );
+ 			if ( $ip === $host ) // Error condition for gethostbyname()
+ 				$ip = false;
+ 		}
+ 		if ( $ip ) {
+ 			if ( '127.0.0.1' === $ip )
+ 				return '';
+ 			$parts = array_map( 'intval', explode( '.', $ip ) );
+ 			if ( 10 === $parts[0] )
+ 				return '';
+ 			if ( 172 === $parts[0] && 16 <= $parts[1] && 31 >= $parts[1] )
+ 				return '';
+ 			if ( 192 === $parts[0] && 168 === $parts[1] )
+ 				return '';
+ 		}
+ 	}
+ 
+ 	if ( empty( $parsed_url['port'] ) )
+ 		return $uri;
+ 
+ 	$port = $parsed_url['port'];
+ 	if ( 80 === $port || 443 === $port || 8080 === $port )
+ 		return $uri;
+ 
+ 	if ( $parsed_home && $same_host && $parsed_home['port'] === $port )
+ 		return $uri;
+ 
+ 	return '';
+ }
+ 
+ /**
+  * Default filter attached to xmlrpc_pingback_error.
+  *
+  * Returns a generic pingback error code unless the error code is 48,
+  * which reports that the pingback is already registered.
+  *
+  * @since 3.5.1
+  * @link http://www.hixie.ch/specs/pingback/pingback#TOC3
+  *
+  * @param IXR_Error $ixr_error
+  * @return IXR_Error
+  */
+ function xmlrpc_pingback_error( $ixr_error ) {
+ 	if ( $ixr_error->code === 48 )
+ 		return $ixr_error;
+ 	return new IXR_Error( 0, '' );
+ }
+ 
  //
  // Cache
  //
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.1.pl /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/default-filters.php /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/default-filters.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/default-filters.php	2012-12-17 16:18:41.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/default-filters.php	2013-01-22 16:32:06.000000000 -0600
***************
*** 192,197 ****
--- 192,199 ----
  add_filter( 'editable_slug',            'urldecode'                           );
  add_filter( 'editable_slug',            'esc_textarea'                        );
  add_filter( 'nav_menu_meta_box_object', '_wp_nav_menu_meta_box_object'        );
+ add_filter( 'pingback_ping_source_uri', 'pingback_ping_source_uri'            );
+ add_filter( 'xmlrpc_pingback_error',    'xmlrpc_pingback_error'               );
  
  // Actions
  add_action( 'wp_head',             'wp_enqueue_scripts',              1     );
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.1.pl /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/functions.php /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/functions.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/functions.php	2012-12-17 16:18:39.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.5.1/wp-includes/functions.php	2013-01-04 16:52:10.000000000 -0600
***************
*** 902,908 ****
  function wp_get_nocache_headers() {
  	$headers = array(
  		'Expires' => 'Wed, 11 Jan 1984 05:00:00 GMT',
- 		'Last-Modified' => '',
  		'Cache-Control' => 'no-cache, must-revalidate, max-age=0',
  		'Pragma' => 'no-cache',
  	);
--- 902,907 ----
***************
*** 910,915 ****
--- 909,915 ----
  	if ( function_exists('apply_filters') ) {
  		$headers = (array) apply_filters('nocache_headers', $headers);
  	}
+ 	$headers['Last-Modified'] = false;
  	return $headers;
  }
  
***************
*** 924,933 ****
   */
  function nocache_headers() {
  	$headers = wp_get_nocache_headers();
  	foreach( $headers as $name => $field_value )
  		@header("{$name}: {$field_value}");
- 	if ( empty( $headers['Last-Modified'] ) && function_exists( 'header_remove' ) )
- 		@header_remove( 'Last-Modified' );
  }
  
  /**
--- 924,948 ----
   */
  function nocache_headers() {
  	$headers = wp_get_nocache_headers();
+ 
+ 	unset( $headers['Last-Modified'] );
+ 
+ 	// In PHP 5.3+, make sure we are not sending a Last-Modified header.
+ 	if ( function_exists( 'header_remove' ) ) {
+ 		@header_remove( 'Last-Modified' );
+ 	} else {
+ 		// In PHP 5.2, send an empty Last-Modified header, but only as a
+ 		// last resort to override a header already sent. #WP23021
+ 		foreach ( headers_list() as $header ) {
+ 			if ( 0 === stripos( $header, 'Last-Modified' ) ) {
+ 				$headers['Last-Modified'] = '';
+ 				break;
+ 			}
+ 		}
+ 	}
+ 
  	foreach( $headers as $name => $field_value )
  		@header("{$name}: {$field_value}");
  }
  
  /**
